    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------
    028     * ContourEntity.java
    029     * ------------------
    030     * (C) Copyright 2002-2004, by David M. O'Donnell and Contributors.
    031     *
    032     * Original Author:  David M. O'Donnell;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: ContourEntity.java,v 1.3.2.1 2005/10/25 20:41:59 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 26-Nov-2002 : Version 1 contributed by David M. O'Donnell (DG);
    040     * 20-May-2004 : Added equals() and clone() methods and implemented
    041     *               Serializable (DG);
    042     *
    043     */
    044
    045    package org.jfree.chart.entity;
    046
    047    import java.awt.Shape;
    048    import java.io.Serializable;
    049
    050    /**
    051     * Represents an item on a contour chart.
    052     *
    053     * @author David M. O'Donnell
    054     */
    055    public class ContourEntity extends ChartEntity
    056                               implements Cloneable, Serializable {
    057
    058        /** For serialization. */
    059        private static final long serialVersionUID = 1249570520505992847L;
    060
    061        /** Holds the index into the dataset for this entity. */
    062        private int index = -1;
    063
    064        /**
    065         * Constructor for ContourEntity.
    066         *
    067         * @param area  the area.
    068         * @param toolTipText  the tooltip text.
    069         */
    070        public ContourEntity(Shape area, String toolTipText) {
    071            super(area, toolTipText);
    072        }
    073
    074        /**
    075         * Constructor for ContourEntity.
    076         *
    077         * @param area  the area.
    078         * @param toolTipText  the tooltip text.
    079         * @param urlText  the URL text.
    080         */
    081        public ContourEntity(Shape area, String toolTipText, String urlText) {
    082            super(area, toolTipText, urlText);
    083        }
    084
    085        /**
    086         * Returns the index.
    087         *
    088         * @return The index.
    089         */
    090        public int getIndex() {
    091            return this.index;
    092        }
    093
    094        /**
    095         * Sets the index.
    096         *
    097         * @param index  the index.
    098         */
    099        public void setIndex(int index) {
    100            this.index = index;
    101        }
    102
    103        /**
    104         * Tests the entity for equality with an arbitrary object.
    105         *
    106         * @param obj  the object (<code>null</code> permitted).
    107         *
    108         * @return A boolean.
    109         */
    110        public boolean equals(Object obj) {
    111            if (obj == this) {
    112                return true;
    113            }
    114            if (obj instanceof ContourEntity && super.equals(obj)) {
    115                ContourEntity ce = (ContourEntity) obj;
    116                if (this.index != ce.index) {
    117                    return false;
    118                }
    119                return true;
    120            }
    121            return false;
    122        }
    123
    124        /**
    125         * Returns a clone of the entity.
    126         *
    127         * @return A clone.
    128         *
    129         * @throws CloneNotSupportedException if cloning is not supported.
    130         */
    131        public Object clone() throws CloneNotSupportedException {
    132            return super.clone();
    133        }
    134
    135    }